package BPpackage;
 
/*
 * AddServerActivity.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */


import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.text.InputType;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class AddServerActivity extends Activity {
	private String bmName = "name";
	private String bmUser = "";
	private String bmPswd = "";
	private String bmSrvr = "";
	private String bmPort = "";
	private String bmPath = "";
	private final static String bookmarks = "ftpjuju.txt";
	private int edit = 0;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Intent origin = this.getIntent();
		edit = origin.getIntExtra("EDIT", edit);
		if (edit == 1) {
			bmName = origin.getStringExtra("NAME");
			bmUser = origin.getStringExtra("USER");
			bmPswd = origin.getStringExtra("PSWD");
			bmSrvr = origin.getStringExtra("SRVR");
			bmPort = origin.getStringExtra("PORT");
			bmPath = origin.getStringExtra("PATH");
		}
		setContentView(R.layout.activity_add_server);
	}

	@Override
	public void onResume() {
		super.onResume();
		if (edit == 1) {
			postBookmark();
		}
	}

	public void postBookmark() {
		TextView tv = (TextView) findViewById(R.id.serverTitle);
		tv.setText("Edit Bookmark: " + bmName);
		EditText field = (EditText) findViewById(R.id.userField);
		field.setText(bmUser);
		field = (EditText) findViewById(R.id.pswdField);
		field.setText(bmPswd);
		field = (EditText) findViewById(R.id.serverField);
		field.setText(bmSrvr);
		field = (EditText) findViewById(R.id.portField);
		field.setText(bmPort);
		field = (EditText) findViewById(R.id.pathField);
		field.setText(bmPath);
	}

	/**
	 * Save Bookmark Methods
	 */

	private String[] getFile() {
		String[] oldfile = new String[16];
		String bookmark = "";
		int limit = 15; // read up 15 lines
		if (edit == 1) { // unless we are editing
			limit = 16; // then we can read up 16
		}

		File file = new File(getBaseContext().getFilesDir(), bookmarks);
		try {
			BufferedReader br = new BufferedReader(new FileReader(file));
			int i = 0;
			while ((bookmark = br.readLine()) != null) {
				oldfile[i] = bookmark;
				i++;
				if (i == limit) {
					break;
				}
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return oldfile;
	}

	private int writeBookmark(String bookmark) {
		String[] oldfile = getFile();
		FileOutputStream writer = null;
		String name = bookmark.substring(0, bookmark.indexOf(":"));

		try {
			writer = openFileOutput(bookmarks, Context.MODE_PRIVATE);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			writer.write(bookmark.getBytes());
			writer.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		for (String string : oldfile) {
			if (string == null) {
				break;
			}
			String name2 = string.substring(0, string.indexOf(":"));
			if (!name.matches(name2)) {
				try {
					writer.write(string.getBytes());
					writer.write(System.getProperty("line.separator")
							.getBytes());
					writer.flush();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		try {
			writer.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return 0;
	}

	/**
	 * called by ui on save button
	 */
	public void saveBookmark(View view) {

		EditText field = (EditText) findViewById(R.id.userField);
		bmUser = field.getText().toString();
		field = (EditText) findViewById(R.id.pswdField);
		bmPswd = field.getText().toString();
		field = (EditText) findViewById(R.id.serverField);
		bmSrvr = field.getText().toString();
		field = (EditText) findViewById(R.id.portField);
		bmPort = field.getText().toString();
		field = (EditText) findViewById(R.id.pathField);
		bmPath = field.getText().toString();

		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle("Name For Bookmark");

		final EditText input = new EditText(this);
		input.setInputType(InputType.TYPE_CLASS_TEXT);
		input.setText(bmName);
		builder.setView(input);

		builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int which) {
				bmName = input.getText().toString();
				String bm = bmName + ":" + bmUser + ":" + bmPswd + ":" + bmSrvr
						+ ":" + bmPort + ":" + bmPath + "\n";

				int val = writeBookmark(bm);
				if (val == 0) {
					Toast.makeText(getBaseContext(),
							"Bookmark \"" + bmName + "\" saved",
							Toast.LENGTH_SHORT).show();
				} else {
					Toast.makeText(getBaseContext(), "Save failed",
							Toast.LENGTH_SHORT).show();
				}
			}
		});
		builder.setNegativeButton("Cancel",
				new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						dialog.cancel();
					}
				});

		builder.show();

	}

	/**
	 * get path from chooser methods
	 */

	static final int PATH_REQUEST = 1;

	public void choosePath(View view) {
		Intent intent = new Intent(this, ChooserActivity.class);
		EditText field = (EditText) findViewById(R.id.userField);
		intent.putExtra("USER", field.getText().toString());
		field = (EditText) findViewById(R.id.pswdField);
		intent.putExtra("PSWD", field.getText().toString());
		field = (EditText) findViewById(R.id.serverField);
		intent.putExtra("SRVR", field.getText().toString());
		field = (EditText) findViewById(R.id.portField);
		intent.putExtra("PORT", field.getText().toString());
		field = (EditText) findViewById(R.id.pathField);
		intent.putExtra("PATH", field.getText().toString());
		startActivityForResult(intent, PATH_REQUEST);
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (requestCode == PATH_REQUEST) {
			String result = data.getStringExtra("RESULT_STRING");
			if (resultCode == RESULT_OK) {
				bmPath = result;
				EditText field = (EditText) findViewById(R.id.pathField);
				field.setText(result);
			} else {
				Toast.makeText(
						getBaseContext(),
						"Path Unchanged. Check entries if unable to use chooser.",
						Toast.LENGTH_LONG).show();
			}
		}
	}


}
