package BPpackage.filters;
 
/*
 * ExpressionFileFilter.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */


import java.io.File;

import BPpackage.FileChooserFileFilter;

import android.os.Parcel;

public class ExpressionFileFilter extends FileChooserFileFilter {
	String expr = ".";

	public ExpressionFileFilter(Parcel in) {
		expr = in.readString();
	}

	public ExpressionFileFilter(String expr) {
		this.expr = expr;
	}

	@Override
	public boolean accept(File pathname) {
		return pathname.getName().matches(expr);
	}

	@Override
	public int describeContents() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public void write(Parcel dest, int flags) {
		dest.writeString(expr);
	}

}
