package BPpackage;
 
/*
 * HelpScreen.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */


import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.view.Gravity;
import android.view.View;
import android.webkit.WebSettings.PluginState;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;
import java.io.File;
import java.lang.String;
import android.net.Uri;

@SuppressLint("SetJavaScriptEnabled")
public class HelpScreen extends Activity {

    public TextView title;
	public PRAWebView wv;

	private class mWVC extends WebViewClient {
		@Override
		public boolean shouldOverrideUrlLoading(WebView view, String url) {

            if (url.startsWith("tel:")) {
                Intent intent = new Intent(Intent.ACTION_DIAL,
                        Uri.parse(url));
                startActivity(intent);
				return true;
            }else if (url.startsWith("mailto:")) {
				String[] emailUri = url.split(":");
				Intent emailIntent = new Intent(
						android.content.Intent.ACTION_SEND);
				emailIntent.setType("text/plain");
				emailIntent.putExtra(android.content.Intent.EXTRA_EMAIL,
						new String[] { emailUri[1] });
				startActivity(emailIntent);
				return true;
			} else {
				wv.loadUrl(url);
				return true;
			}
			
		}
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.activity_helpscreen);
        findViews();

		WebSettings wvOptions = wv.getSettings();
		wvOptions.setJavaScriptEnabled(true);
		wvOptions.setBuiltInZoomControls(true);
		wvOptions.setUseWideViewPort(true);
		wvOptions.setPluginState(PluginState.ON);
		wvOptions.setSaveFormData(true);
		wvOptions.setMinimumFontSize(10);
		wvOptions.setDefaultTextEncodingName("utf-8");
		wv.setFocusable(true);
		wv.setFocusableInTouchMode(true);
		wv.setScrollBarStyle(View.SCROLLBARS_INSIDE_OVERLAY);
		wv.setWebViewClient(new mWVC());
		wv.setMaster(this);
		wv.loadUrl("file:///android_asset/index.html");

	}

	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		wv = (PRAWebView) findViewById(R.id.webview);
	}

}
