package BPpackage;
 
/*
 * BoilerPlate.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */


import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.view.LayoutInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class BoilerPlate extends ListActivity {

	public Map<String, String> dbs = new HashMap<String, String>();
	static final String[] FRUITS = new String[] { "Apple", "Avocado", "Banana",
		"Blueberry", "Coconut", "Durian", "Guava", "Kiwifruit",
		"Jackfruit", "Mango", "Olive", "Pear", "Sugar-apple" };

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_boilerplate);
	}


	/**
	 * call on resume when list is altered
	 **/
	@Override
	public void onResume() {
		super.onResume();

		final String[] list = buildList();
		setListAdapter(new ArrayAdapter<String>(this,
				R.layout.pra_list_item, list));

		EdgeEffectListView listView = (EdgeEffectListView) getListView();
		listView.setTextFilterEnabled(true);

		listView.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {
				String result = ((TextView) view).getText().toString();
				String fruit = dbs.get(result);
				Intent intent = new Intent();
				intent.putExtra("FRUIT", fruit);
				setResult(RESULT_OK, intent); 
				finish();
			}
		});

		final String[] menu_array = { 
			"One", 
			"Two", 
		};

		final Context c = this;

		listView.setOnItemLongClickListener(new OnItemLongClickListener() {
		 
		    @Override 
			public boolean onItemLongClick(AdapterView parentView, View view, int position, long id) {
				final String name = ((TextView) view).getText().toString();

				LayoutInflater inflater = getLayoutInflater();
				final ArrayList<String> list = new ArrayList<String>();
				for (int i = 0; i < menu_array.length; ++i) {
					list.add(menu_array[i]);
				}
				
				AlertDialog.Builder builder = new AlertDialog.Builder(c);
				final ArrayAdapter adapter = new ArrayAdapter(c, R.layout.pra_list_item, list);
				builder.setView(inflater.inflate(R.layout.list_context_menu, null))
					.setAdapter(adapter, new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						String result = (String) adapter.getItem(which);
						if (result.matches("One")){
							Toast.makeText(getApplicationContext(), "You chose One", Toast.LENGTH_SHORT).show();
							onResume();
						} else if (result.matches("Two")){
							Toast.makeText(getApplicationContext(), "You chose Two", Toast.LENGTH_SHORT).show();
							onResume();
						}
						
					}
						})
					.create()
					.show();
				return true;
			}
			});

	}

	private String[] buildList() {
		List<String> alist = new ArrayList<String>();
		for (String f : FRUITS) {
		    alist.add(f);
		    dbs.put(f, f.toLowerCase());
		}

		Collections.sort(alist);
		String[] list = new String[alist.size()];
		alist.toArray(list);
		return list;
	}


	@Override
	public void onBackPressed() {
		Intent intent = new Intent();
		setResult(RESULT_CANCELED, intent);
		finish();
	}
}
