package BPpackage;
 
/*
 * Mu2.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */


import java.lang.Exception;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *
 *  See mu2 at http://tinybashcgis.tuxfamily.org/ for usage
 *
 **/
public class Mu2 {

	public String HDR = "<html> \n"
			+ "<head> \n"
			+ "<title>TITLE</title> \n"
			+ "</head> \n" + "<body> \n"
			+ "<h2>TITLE</h2>";

	public String FTR = " \n" + "</body> \n" + "</html> \n";

	public String RIGHTS = "<h4>Copyright Notice</h4> \n"
			+ "<p>TITLE is copyrighted DATE by AUTHOR \n"
			+ "<p>All rights reserved. No part of this book may be used or reproduced in any \n"
			+ "manner whatsoever without written permission, except in the case of brief \n"
			+ "quotations embodied in critical articles or reviews. \n";

	Map<String, String> begin = new HashMap<String, String>();
	Map<String, String> middle = new HashMap<String, String>();
	Map<String, String> end = new HashMap<String, String>();

	public Mu2() {
		begin.put("A", "<h3>"); // author
		begin.put("B", "<center>-x-x-x-"); // asterisks
		begin.put("C", "<hr align=left width=\"50px\">\n<h3>"); // chapter
		begin.put("L", "<p>");
		begin.put("O", "<ol>");
		begin.put("P", "<hr align=left width=\"75px\">\n<p>&nbsp;\n<h2>"); // part
		begin.put("Q", "<blockquote>"); // quotation
		begin.put("R", "<hr align=left width=\"75px\">"); // rights
		begin.put("S", "<hr align=left width=\"25px\">\n<h4>"); // subchapter
		begin.put("T", "<h2>"); // title
		begin.put("U", "<ul>");
		begin.put("V", "<blockquote>"); // verse

		middle.put("A", "");
		middle.put("B", "");
		middle.put("C", "");
		middle.put("L", "<br>");
		middle.put("O", "<li>");
		middle.put("P", "");
		middle.put("Q", "");
		middle.put("R", "");
		middle.put("S", "");
		middle.put("T", "");
		middle.put("U", "<li>");
		middle.put("V", "<br>");

		end.put("A", "</h3>");
		end.put("B", "</center>");
		end.put("C", "</h3>\n<p>&nbsp;\n");
		end.put("L", "</p>");
		end.put("O", "</ol>");
		end.put("P", "</h2>\n<p>&nbsp;\n");
		end.put("Q", "</blockquote>");
		end.put("R", "");
		end.put("S", "</h4>");
		end.put("T", "</h2>");
		end.put("U", "</ul>");
		end.put("V", "</blockquote>");
	}

	String LAST = "";
	String MID = "";
	String title = "";
	String author = "";
	String date = "";
    String[] tmp;

	public String convert(String text) {
		if (text.startsWith(".")) {
			text = text.replace(".", "");
			tmp = text.split(":");
			if (tmp.length == 2) {
				if (tmp[0].matches("T")) {
					title = tmp[1];
					HDR = HDR.replace("TITLE", tmp[1]);
					text =  LAST + HDR;
				} else if (tmp[0].matches("A")) {
					author = tmp[1];
					text = LAST;
				} else if (tmp[0].matches("R")) {
					date = tmp[1];
					RIGHTS = RIGHTS.replace("TITLE", title);
					RIGHTS = RIGHTS.replace("AUTHOR", author);
					RIGHTS = RIGHTS.replace("DATE", date);
					LAST = end.get(tmp[0]);
					text =  LAST + begin.get(tmp[0]) + RIGHTS;
				} else {
					text = LAST + begin.get(tmp[0]) + tmp[1];
					MID = middle.get(tmp[0]);
					LAST = end.get(tmp[0]);
				}

			} else {

				MID = middle.get(text);
				LAST = end.get(text);
 				text = LAST + begin.get(text);
			}
		} else {
			if (text.matches("")) {
				text = LAST + "<p>";
				LAST = "";
				MID = "";
			} else {
				text = text.replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;");
				text = MID + text + " ";
			}
		}
		return text;
	}

}
