package BPpackage;
 
/*
 * Result.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */


import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import java.lang.Exception;
import java.lang.Runnable;


public class Result extends Activity {

	public PRAFileHandler fhandler = null;
    public TextView title;
    public TextView lname;
    public TextView lone;
    public TextView ltwo;
	public EditText ename;
	public EditText eone;
	public EditText etwo;
	public Button save;

	public int dataLen = 3;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		fhandler = new PRAFileHandler(this);
		setContentView(R.layout.activity_result);
		findViews();
		Intent i = getIntent();
		String data = i.getStringExtra("DATA");
		String[] tokens = data.split("\t");
		ename.setText(tokens[0]);
		if (tokens.length == dataLen){
			eone.setText(tokens[1]);
			etwo.setText(tokens[2]);
		}
	}


	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		lname = (TextView) findViewById(R.id.lname);
		lone = (TextView) findViewById(R.id.lone);
		ltwo = (TextView) findViewById(R.id.ltwo);
		ename = (EditText) findViewById(R.id.ename);
		ename.setGravity(Gravity.CENTER);
		eone = (EditText) findViewById(R.id.eone);
		eone.setGravity(Gravity.CENTER);
		etwo = (EditText) findViewById(R.id.etwo);
		etwo.setGravity(Gravity.CENTER);
		save = (Button) findViewById(R.id.save);
	}

    public void save(View view){
		String name = ename.getText().toString();
		if ((name == null) || (name.matches(""))){
			toaster("Timer must have a name", Toast.LENGTH_SHORT);
			return;
		}
		String one = eone.getText().toString();
		if ((one == null) || (one.matches(""))){
			toaster("Error: no first thing", Toast.LENGTH_SHORT);
			return;
		}
		String two = etwo.getText().toString();
		if ((two == null) || (two.matches(""))){
			toaster("Error: no second thing", Toast.LENGTH_SHORT);
			return;
		}

		String data = name+ "\t" +one+ "\t" +two;
		Intent intent = new Intent();
		intent.putExtra("DATA", data);
		setResult(RESULT_OK, intent); 
		finish();
    }


	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			Intent intent = new Intent();
			setResult(RESULT_CANCELED, intent);
			finish();
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, R.string.exit_bkbtn, Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}


	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, text, length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}

}
