package BPpackage;
 
/*
 * Set.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */


import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.text.InputType;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.MenuItem;
import android.view.View.OnClickListener;
import android.view.View;
import android.view.Window;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.lang.Runnable;
import java.lang.String;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Set extends ListActivity {

	public Map<String, String> dbs;
	public URLDecoder decoder = new URLDecoder();
	public PRAFileHandler fhandler = new PRAFileHandler(this);
	public String sep = "\t"; // must be invalid URL char
	public String prefix = "set";
	public String setName = "Set";
	public String this_app_dir = "";
	public final static int PH = 0;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_set);
		// toaster("Press red '?' for help.", Toast.LENGTH_SHORT);
		new SimpleEula(this).show();
	}


	@Override
	public void onResume() {
		super.onResume();

		dbs = new HashMap<String, String>();
		final String[] list = buildList();
		setListAdapter(new ArrayAdapter<String>(this, R.layout.pra_list_item, list));

		EdgeEffectListView listView = (EdgeEffectListView) getListView();
		listView.setTextFilterEnabled(true);

		final Context c = this;
		listView.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {
				String result = ((TextView) view).getText().toString();
				String fname = dbs.get(result);
				if (fname.matches("new")){
					newSet();
				} else {
					Intent intent = new Intent(c, Subset.class);
					intent.putExtra("SET", fname);
					startActivityForResult(intent, PH);
				}
			}
		});


		final String[] menu_array = { 
			"Export", 
			"Import", 
			"Remove", 
		};

		listView.setOnItemLongClickListener(new OnItemLongClickListener() {
		 
		    @Override 
			public boolean onItemLongClick(AdapterView parentView, View view, int position, long id) {
				final String name = ((TextView) view).getText().toString();
				final String fname = dbs.get(name); // full path name in HashMap dbs
				if (name.matches("New "+setName)){ return false; }

				LayoutInflater inflater = getLayoutInflater();
				final ArrayList<String> list = new ArrayList<String>();
				for (int i = 0; i < menu_array.length; ++i) {
					list.add(menu_array[i]);
				}
				
				AlertDialog.Builder builder = new AlertDialog.Builder(c);
				final ArrayAdapter adapter = new ArrayAdapter(c, R.layout.pra_list_item, list);
				builder.setView(inflater.inflate(R.layout.list_context_menu, null))
					.setAdapter(adapter, new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						String result = (String) adapter.getItem(which);
						if (result.matches("Export")){
							exportSet(name);
						} else if (result.matches("Import")){
							importSet();
						} else if (result.matches("Remove")){
							removeSet(name);
						}
						
					}
						})
					.create()
					.show();
				return true;
			}
			});


	}


	private String[] buildList() {
		String fname = "";
		String title = "";
		String[] tokens;
		File internal = getFilesDir();
		File[] files = internal.listFiles();
		List<String> alist = new ArrayList<String>();
		for (File inFile : files) {
		    fname = inFile.toString();
			tokens	= fname.split("/");
			fname = tokens[tokens.length - 1];
			if (fname.startsWith(prefix)){
				title = decoder.decode(fname.replace(prefix, ""));
				alist.add(title);
				dbs.put(title, fname);
			}
		}

		Collections.sort(alist);
		alist.add("New "+setName);
		dbs.put("New "+setName, "new");
		String[] list = new String[alist.size()];
		alist.toArray(list);
		return list;
	}


	private void importSet(){
		File sdcard = Environment.getExternalStorageDirectory();
		File[] files = sdcard.listFiles();
		String[] tokens;
		String src = "";
		String fname = "";

		for (File f : files ){
			src = f.toString();
			tokens	= src.split("/");
			fname = tokens[tokens.length - 1];
			if (fname.startsWith(prefix)){
				if (dbs.containsValue(fname)){
					getName(fname, src);
				} else {
					finishImport(fname, src);
				}
			}
		}
	}

	private void getName(String fname, String path){
		final String dir = path;
		final String orig = fname;
		String Dname = decoder.decode(fname.replace(prefix, ""));

		final Dialog dialog = new Dialog(this);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setContentView(R.layout.alert_two_edit);
		TextView t = (TextView) dialog.findViewById(R.id.dTitle);
		t.setText("Duplicate "+setName+" Name");
		TextView m = (TextView) dialog.findViewById(R.id.dMessage);
		m.setText("Rename import or overwrite existing content. Backbutton cancels.");
		final EditText e = (EditText) dialog.findViewById(R.id.dEdit);
		e.setInputType(InputType.TYPE_CLASS_TEXT);
		e.setText(Dname);

		Button pos = (Button) dialog.findViewById(R.id.dPos);
		pos.setText("Enter");
		pos.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				String name = e.getText().toString();   
				name = name.replaceAll("[^0-9A-Za-z\\s\\.\\-\\']", "");
				try {
					name = URLEncoder.encode(name,"UTF-8");
				} catch (UnsupportedEncodingException u) { ; }
				finishImport(prefix + name, dir);
				dialog.dismiss();
			}
			});
		
		Button neg = (Button) dialog.findViewById(R.id.dNeg);
		neg.setText("Overwrite");
		neg.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				finishImport(orig, dir);
				dialog.dismiss();
			}
			});
		
		dialog.show();
	}

	// fname is new encoded set name, path is original file to import
	private void finishImport(String fname, String path){
		File sdcard = Environment.getExternalStorageDirectory();
		String[] tokens	= path.split("/");
		String src = tokens[tokens.length - 1];
		String[] orig = fhandler.getExtFileAsArray(sdcard.toString()+"/", src);
		fhandler.writeArrayToFile(orig, fname);
		onResume();
	}

	private void newSet(){
		final Dialog dialog = new Dialog(this);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setContentView(R.layout.alert_two_edit);
		TextView t = (TextView) dialog.findViewById(R.id.dTitle);
		t.setText("New "+setName);
		TextView m = (TextView) dialog.findViewById(R.id.dMessage);
		m.setText("Enter "+setName+" Name");
		final EditText e = (EditText) dialog.findViewById(R.id.dEdit);
		e.setInputType(InputType.TYPE_CLASS_TEXT);

		Button pos = (Button) dialog.findViewById(R.id.dPos);
		pos.setText("Create");
		pos.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				String name = e.getText().toString();   
				name = name.replaceAll("[^0-9A-Za-z\\s\\.\\-\\']", "");
				String test = dbs.get(name);
				if ((test == null) || (test.matches(""))){
					String fname = prefix;
					try {
						fname = fname + URLEncoder.encode(name,"UTF-8");
					} catch (UnsupportedEncodingException u) { ; }
					fhandler.touchFile(fname);
					dialog.dismiss();
					onResume();
				} else {
					dialog.dismiss();
				}
			}
			});
		
		Button neg = (Button) dialog.findViewById(R.id.dNeg);
		neg.setText("Cancel");
		neg.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				dialog.dismiss();
			}
			});
		
		dialog.show();

	}

	private void exportSet(String name){
		String fname = dbs.get(name);
		File sdcard = Environment.getExternalStorageDirectory();
		String[] file2export = fhandler.getFileAsArray(fname);
		String exportfile = new File(sdcard, fname).toString();
		fhandler.writeArrayToExtFile(file2export, exportfile);
		toaster(setName+" "+ name+" exported", Toast.LENGTH_SHORT);
	}


	private void removeSet(String name){
		final String fname = dbs.get(name);

		final Dialog dialog = new Dialog(this);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setContentView(R.layout.alert_two);
		TextView t = (TextView) dialog.findViewById(R.id.dTitle);
		t.setText(setName+" Deletion");
		TextView m = (TextView) dialog.findViewById(R.id.dMessage);
		m.setText("Remove "+name+"?");
		
		Button pos = (Button) dialog.findViewById(R.id.dPos);
		pos.setText("Delete");
		pos.setOnClickListener(new OnClickListener() {
				@Override
					public void onClick(View v) {
                    fhandler.remove(fname);
					dbs.remove(fname);
					dialog.dismiss();
					onResume();
				}
			});
		
		Button neg = (Button) dialog.findViewById(R.id.dNeg);
		neg.setText("Cancel");
		neg.setOnClickListener(new OnClickListener() {
				@Override
					public void onClick(View v) {
					dialog.dismiss();
				}
					});
		
		dialog.show();


	}


	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, text, length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}

    // public void help(View view){
	// 	Intent intent = new Intent(this, HelpScreen.class);
	// 	startActivity(intent);
    // }


	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			super.onBackPressed();
			return;
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, R.string.exit_bkbtn, Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}



	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (resultCode == RESULT_CANCELED) {
			finish();
		}
    }

}
