#!/bin/bash
# pr_actBlank.sh
# created and copyrighted:  6 May 13
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

if [ "$dot" == "" ]; then
	dot=$HOME/.pride
	source $dot/pride.rc
	source $dot/pride.src
fi


setSrc
PLT=$dot/plate/activity/Blank

#
# beta descent into dirs
#
DEST=`ls -F $src | grep / | tr -d /`
zenList "Choose Directory" "$name $DEST"

if [ -d $src/$CHOICE ]; then
	src=$src/$CHOICE 
	package=$package.$CHOICE
fi

LIST=`grep -l Activity $src/*`
for l in $LIST; do
	echo -n `basename $l` | cut -d\. -f1  | tr -d [:space:] >> pr_tmp
	echo -n "|"  >> pr_tmp
done
LIST=`cat pr_tmp`
rm pr_tmp

NEW=`zenity --forms --width=350 --title="New Activity" --add-entry="Activity Name" --add-list="Parent Activity" --column-values=Activities --list-values="$LIST"`
if [ "$NEW" == "" ]; then
	exit
fi

token=`echo $NEW | cut -d\| -f1`
if [ "$token" == "" ]; then
	echo "exiting"
	exit
fi

tokenlc=`echo $token | tr [:upper:] [:lower:]`
parent=`echo $NEW | cut -d\| -f2`
if [ "$parent" == "" ]; then
	echo "public class
{
}" > $src/4Parent.java
	parent=4Parent
fi
#
# end beta
#

parentImport
XMLmanifest
XMLvalues

# files
cp $PLT/res/layout/activity_boilerplate.xml $PRIDE/$name/res/layout/activity_$tokenlc.xml
cp $PLT/src/BoilerPlate.java $src/$token.java

pr_sr.sh $src BPpackage $package
prReplace