#!/bin/bash
# pr_injectPlate.sh
# created and copyrighted:  4 May 13
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

if [ "$dot" == "" ]; then
	dot=$HOME/.pride
	source $dot/pride.rc
	source $dot/pride.src
fi

plate=$dot/plate/project
token=`cat $dot/name`
tokenlc=`echo $name | tr [:upper:] [:lower:]`
package=`cat $dot/package`
path=`cat $dot/package | tr \. / `

tgt=$PRIDE/$token

zenity --text="Injecting Project Plate" --progress --pulsate&
ZEN=$!


# project/
cp $plate/AndroidManifest.xml $tgt/

# market images
cp -r $plate/market/ $tgt/

# project/res
DIRS=`ls $plate/res`
for dir in $DIRS; do
    mkdir $tgt/res/$dir
    cp $plate/res/$dir/* $tgt/res/$dir
    done

# project/src
cp $plate/src/* $tgt/src/$path/

# update namespace
mv $tgt/src/$path/BoilerPlate.java $tgt/src/$path/$token.java
prReplace

kill -HUP $ZEN

#
# overwrite and add personal plate 
#
if  [ "$1" == "" ] && [ "$PERSONAL" != "" ]; then
    zenity --question --text="Inject personal plate into $token"
    if [ $? -eq 0 ]; then
		pr_personalPlate.sh
    fi
fi


