#!/bin/bash
# pr_projectBatchLoad.sh
# created and copyrighted:  12 aug 13
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

if [ "$dot" == "" ]; then
	dot=$HOME/.pride
	source $dot/pride.rc
	source $dot/pride.src
fi


names=`ls -F $PRIDE | grep / | tr -d /`
for l in $names; do
	echo "FALSE "$l >> pr_tmp
done
names=`cat pr_tmp`
rm pr_tmp

zenChoices Select Project "$names"


# set up adb
ADB=$ANDROID_HOME/platform-tools/adb
skill -9 adb
$ADB start-server
$ADB shell setprop log.redirect-stdio true
DEVICES=`$ADB devices | awk '{ if ($0 ~ /device/ ){ ret = split($0, a, " ") }\
				{ if (ret == 2) {print a[1]}; ret = 0; }}'`

# process choices
for c in $CHOICES; do

	cd $PRIDE/$c
	name=`cat .name`
	package=`cat .package`

	for d in $DEVICES; do
		adb -s $d -d install -r bin/$name-debug.apk
		adb -s $d shell am start -n $package/.$name
	done

done


