#!/bin/bash
# pr_projectClone.sh
# created and copyrighted:  Thu 26 Dec 2013 03:40:55 PM EST
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

if [ "$dot" == "" ]; then
	dot=$HOME/.pride
	source $dot/pride.rc
	source $dot/pride.src
fi

PLT=$dot/plate/app

DIRS=`ls -F $PRIDE | grep / | tr -d /`
zenList "Clone Project" "$DIRS"

app=$CHOICE
applc=`echo $app | tr [:upper:] [:lower:]`
oldpkg=`cat $PRIDE/$app/.package`

zenEntry "CloneName (CamelCase)"
if [ -d $PRIDE/$CHOICE ]; then
	zenWarn "$PRIDE/$name exists. Exiting"
	exit
else
	name=$CHOICE
fi

if [ "$DOMAIN" == "" ]; then
	zenEntry "Package Domain (com.you.etc)"
	DOMAIN=$CHOICE
fi

namelc=`echo $name | tr [:upper:] [:lower:]`
package=$DOMAIN.$namelc


cp -r $PRIDE/$app $PRIDE/$name
rm -r $PRIDE/$name/bin
rm -r $PRIDE/$name/gen
opkg=`echo $oldpkg | tr . /`
pkg=`echo $package | tr . /`
mv $PRIDE/$name/src/$opkg $PRIDE/$name/src/$pkg
mv $PRIDE/$name/src/$pkg/$app.java $PRIDE/$name/src/$pkg/$name.java
echo $name > $PRIDE/$name/.name
echo $package > $PRIDE/$name/.package

pr_sr.sh $PRIDE/$name $app $name
pr_sr.sh $PRIDE/$name $oldpkg $package


zenity --question --text="New icons for $name?"
if [ $? -eq 0 ]; then
	rm $PRIDE/$name/market/*.png
	cp ~/.pride/plate/project/market/* $PRIDE/$name/market/
fi

$EDITOR $PRIDE/$name/res/values/strings.xml

cp $PRIDE/$name/.name ~/.pride/name
cp $PRIDE/$name/.package ~/.pride/package

