#!/bin/bash
# pr_snapshot.sh
# created and copyrighted:  Mon May 13 11:05:38 EDT 2013
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

if [ "$dot" == "" ]; then
	dot=$HOME/.pride
	source $dot/pride.rc
	source $dot/pride.src
fi


name=`cat $dot/name`

if [ ! -d $SNAPSHOT ]; then
    mkdir $SNAPSHOT
    fi

zenList "Snapshot $name" "Backup Restore Version VersionRestore RemoveDirs"

if [ "$CHOICE" == "Backup" ]; then
    rm -r $SNAPSHOT/$name
    cp -r $PRIDE/$name $SNAPSHOT/$name

elif [ "$CHOICE" == "Restore" ]; then
	zenity --question --text="Are you sure?" || exit
    if [ ! -d $SNAPSHOT/$name ]; then
        zenWarn "$SNAPSHOT/$name does not exist\nExiting..."
        exit
        fi
    rm -r $PRIDE/$name
    cp -r $SNAPSHOT/$name $PRIDE/$name
#	touch $src/*

elif [ "$CHOICE" == "Version" ]; then
	zenEntry "Version Name"
    cp -r $PRIDE/$name $SNAPSHOT/$name$CHOICE

elif [ "$CHOICE" == "VersionRestore" ]; then

	names=`ls -F $SNAPSHOT/$name?* | grep / | tr -d : `
	for l in $names; do
		l=`basename $l`
		echo $l >> pr_tmp
	done
	names=`cat pr_tmp`
	if [ "$names" == "" ]; then
		zenity --info --text="No $name directories in $SNAPSHOT"
		exit
	fi
	rm pr_tmp
	zenList "Choose Version" "$names"

    rm -r $PRIDE/$name
    cp -r $SNAPSHOT/$CHOICE $PRIDE/$name
	touch $src/*

else #remove dirs

	names=`ls -F $SNAPSHOT | grep / | tr -d / `
	for l in $names; do
		echo "FALSE "$l >> pr_tmp
	done
	names=`cat pr_tmp`
	if [ "$names" == "" ]; then
		zenity --info --text="No directories in $SNAPSHOT"
		exit
	fi

	rm pr_tmp

	zenChoices Select Dirs "$names"
	
	for c in $CHOICES; do
		rm -r $SNAPSHOT/$c
	done
fi

