#!/bin/bash
# (SR) pr_sr.sh
# created and copyrighted: 01 Nov 05
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GPL
# license. See COPYING for specifics.
#

usage()
{
	echo ""
	echo "usage: SR path old [new]"
	echo "  w/out new: lists files and shows old line"
	echo "   with new: lists files and replaces old with new"
	echo ""
	exit 1
}

# check for correct usage
if [ "$1" == "-?" ] || [ "$1" == "" ]; then
	usage
fi

if [ $# -eq 2 ]; then
	grep --color=auto -r "$2" "$1"/*
else
	FILES=`grep --color=never -r -l "$2" "$1"/*`
	for file in $FILES; do
		echo $file
		perm=`stat -c %a $file`
		sed 's/'"$2"'/'"$3"'/g' < $file > _tmp
		mv _tmp $file
		chmod $perm $file
	done
fi
