#!/bin/bash
# pr_stripImgs.sh
# created and copyrighted:  Sun 26 Jan 2014 09:34:35 AM EST
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

if [ "$dot" == "" ]; then
	dot=$HOME/.pride
	source $dot/pride.rc
	source $dot/pride.src
fi

name=`cat $dot/name`
dirs=`ls $PRIDE/$name/res`

cd
zenity --text="Removing Unused Images" --progress --pulsate &
ZEN=$!

UN=`$ANDROID_HOME/tools/lint --check UnusedResources $PRIDE/$name/ | grep png`

found=""
if [ "$UN" == "" ]; then
	kill -HUP $ZEN
	zenWarn "No unused images found. Did you build the project? Lint requires class files."
else
	for un in $UN; do 
		f=`echo $un | grep res/ | tr -d :`
		if [ "$f" != "" ]; then
			f=`basename $f`
			for d in $dirs; do
				rm $PRIDE/$name/res/$d/$f 2> /dev/null
				done
		fi
	done
	kill -HUP $ZEN
fi
