#!/usr/bin/awk -f
#
# REMOVE_UNUSED_IMPORTS - strip unused and duplicate imports in java files.
#
# $v 14B4:14B4:0

BEGIN {
    if (ARGC != 2) {
        print "usage: [DIFF=1] "ARGV[0]" <JavaFile>" > "/dev/stderr"
        exit 1
    }
    ARGV[2] = ARGV[1] # we will read the file twice, once for checking,
    ARGC++            # once for (maybe) rewriting.
    IMPORTC = split("", IMPORTV)
    split("", MATCHV)
    SORT = "/usr/bin/sort"
    NEW = ARGV[1]".NEW"
    STRIPOK = 0
	print ARGV[1]
}

(FNR != NR) {
    if ((IMPORTC + STRIPOK++) < 1) # STRIPOK needs to be >0 below.
        exit 0 # nothing to remove.
	for (i in IMPORTV)
		if (IMPORTV[i] > 0)
			print "Unused: "i | SORT
    close(SORT)
    while (STRIPOK > 0) {
        if ($1 == "import") {
            i = $2
            sub(/;.*$/, "", i)
            if (IMPORTV[i]++ == 0) # +1 to strip further duples.
               print >NEW
        } else {
            print >NEW
        }
        STRIPOK = getline
    }
    close(NEW)
    if (ENVIRON["DIFF"])
        system("diff -u "ARGV[1]" "NEW)
}

($1 == "import") { 
     sub(/;.*$/, "")
     if ($2 in IMPORTV) {
         print "Duplicated: "$2 | SORT
         STRIPOK = 1
         next
     }
     $1=$2
     sub(/^[^A-Z]*/, "", $1)

	 # generalize for n fields, not just 2?
	 if ($1 ~ /\./) {
		 split($1, ar, ".")
		 $1 = ar[2]
	 }

     IMPORTV[$2] = split($1, tmpv, ".")
     IMPORTC++
     for (i in tmpv)
         MATCHV[tmpv[i]] = MATCHV[tmpv[i]]" "$2
     next
}

(IMPORTC) { 
    gsub(/"[^"]*"/, "") # don't bother with constants.
    gsub(/[^\t _A-Za-z0-9]/, " ")
    for (i=1; i<=NF; i++)
        if ($i in MATCHV) {
            split(MATCHV[$i], tmpv)
            for (j in tmpv)
                (--IMPORTV[tmpv[j]] == 0) && IMPORTC--
            delete MATCHV[$i]
        }
}

END {
	system("if [ -e "NEW" ]; then mv "NEW" "ARGV[1]"; fi")
}
# EoF
